<!DOCTYPE html>
<html lang="en">
	<head>
		<meta charset="UTF-8" />
		<meta http-equiv="X-UA-Compatible" content="IE=edge" />
		<meta name="viewport" content="width=device-width, initial-scale=1.0" />
		<title>Title new</title>
		<!-- Link boostrap 4-->
		<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" />
		<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
		<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

		<!-- Link fontawesome-->
		<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />

		<!-- Data Table-->
		<link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css" />
		<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
		<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
	</head>

	<body>
		<div class="container-fluid">
			<h2 class="text-center mb-3">Managing courses</h2>
			<div class="row my-4 ml-2">
				<button class="btn btn-info" id="btn-add-course"><i class="fas fa-plus"></i> &nbsp; Add Course</button>
			</div>
			<table class="table table-hover table-striped" id="table-courses">
				<thead>
					<tr>
						<th>No</th>
						<th>Course Code</th>
						<th>Course Name</th>
						<th>Price</th>
						<th>Discount Price</th>
						<th>Duration</th>
						<th>Level</th>
						<th>Teacher Name</th>
						<th>Popular</th>
						<th>Trending</th>
						<th>Action</th>
					</tr>
				</thead>
				<tbody></tbody>
			</table>
		</div>
		<!-- Modal add new course -->
		<div id="modal-add-course" class="modal fade" role="dialog">
			<div class="modal-dialog">
				<div class="modal-content">
					<div class="modal-header">
						<h4 class="modal-title">Add Course</h4>
					</div>
					<div class="modal-body">
						<form>
							<div class="form-group">
								<label>Course Code</label>
								<input type="text" id="inp-add-course-code" class="form-control" />
							</div>
							<div class="form-group">
								<label>Course Name</label>
								<input type="text" id="inp-add-course-name" class="form-control" />
							</div>
							<div class="form-group">
								<label>Price</label>
								<input type="text" id="inp-add-price" class="form-control" />
							</div>
							<div class="form-group">
								<label>Discount Price</label>
								<input type="text" id="inp-add-discount-price" class="form-control" />
							</div>
							<div class="form-group">
								<label>Duration</label>
								<input type="text" id="inp-add-duration" class="form-control" />
							</div>
							<div class="form-group">
								<label>Level</label>
								<select id="select-add-level" class="form-control">
									<option value="Beginner">Beginner</option>
									<option value="Intermediate">Intermediate</option>
									<option value="Advanced">Advanced</option>
								</select>
							</div>
							<div class="form-group">
								<label>Cover Image</label>
								<input type="text" id="inp-add-cover-image" class="form-control" />
							</div>
							<div class="form-group">
								<label>Teacher Name</label>
								<input type="text" id="inp-add-teacher-name" class="form-control" />
							</div>
							<div class="form-group">
								<label>Teacher Picture</label>
								<input type="text" id="inp-add-teacher-photo" class="form-control" />
							</div>
							<div class="form-group">
								<input type="checkbox" id="ckb-add-popular" />
								<label>Popular</label>
								<input type="checkbox" id="ckb-add-trending" />
								<label>Trending</label>
							</div>
						</form>
					</div>
					<div class="modal-footer">
						<button type="button" class="btn btn-info" id="btn-add-create-course">Create</button>
						<button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
					</div>
				</div>
			</div>
		</div>

		<!-- Modal edit course -->
		<div id="modal-edit-course" class="modal fade" role="dialog">
			<div class="modal-dialog">
				<div class="modal-content">
					<div class="modal-header">
						<h4 class="modal-title">Edit Course</h4>
					</div>
					<div class="modal-body">
						<form>
							<div class="form-group">
								<label>Course Code</label>
								<input type="text" id="inp-edit-course-code" class="form-control" />
							</div>
							<div class="form-group">
								<label>Course Name</label>
								<input type="text" id="inp-edit-course-name" class="form-control" />
							</div>
							<div class="form-group">
								<label>Price</label>
								<input type="text" id="inp-edit-price" class="form-control" />
							</div>
							<div class="form-group">
								<label>Discount Price</label>
								<input type="text" id="inp-edit-discount-price" class="form-control" />
							</div>
							<div class="form-group">
								<label>Duration</label>
								<input type="text" id="inp-edit-duration" class="form-control" />
							</div>
							<div class="form-group">
								<label>Level</label>
								<select id="select-edit-level" class="form-control">
									<option value="Beginner">Beginner</option>
									<option value="Intermediate">Intermediate</option>
									<option value="Advanced">Advanced</option>
								</select>
							</div>
							<div class="form-group">
								<label>Cover Image</label>
								<input type="text" id="inp-edit-cover-image" class="form-control" />
							</div>
							<div class="form-group">
								<label>Teacher Name</label>
								<input type="text" id="inp-edit-teacher-name" class="form-control" />
							</div>
							<div class="form-group">
								<label>Teacher Picture</label>
								<input type="text" id="inp-edit-teacher-photo" class="form-control" />
							</div>
							<div class="form-group">
								<input type="checkbox" id="ckb-edit-popular" />
								<label>Popular</label>
								<input type="checkbox" id="ckb-edit-trending" />
								<label>Trending</label>
							</div>
						</form>
					</div>
					<div class="modal-footer">
						<button type="button" class="btn btn-info" id="btn-edit-update-course">Update</button>
						<button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
					</div>
				</div>
			</div>
		</div>

		<!-- Modal delete course-->
		<div id="modal-delete-course" class="modal fade" role="dialog">
			<div class="modal-dialog">
				<div class="modal-content">
					<div class="modal-header">
						<h4 class="modal-title">Delete Course</h4>
					</div>
					<div class="modal-body">
						<p>Are you sure you want to delete this course?</p>
					</div>
					<div class="modal-footer">
						<button type="button" class="btn btn-danger" id="btn-delete-confirm-course">Confirm</button>
						<button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
					</div>
				</div>
			</div>
		</div>
	</body>

	<script>
		"use strict";
		/*** REGION 1 - Global variables */
		var gBASE_URL = "https://624abe0dfd7e30c51c110ac6.mockapi.io/api/v1/";
		var gNAME = ["id", "courseCode", "courseName", "price", "discountPrice", "duration", "level", "teacherName", "isPopular", "isTrending", "action"];
		var gCOL_NO = 0;
		var gCOL_COURSE_CODE = 1;
		var gCOL_COURSE_NAME = 2;
		var gCOL_PRICE = 3;
		var gCOL_DISCOUNT_PRICE = 4;
		var gCOL_DURATION = 5;
		var gCOL_LEVEL = 6;
		var gCOL_TEACHER_NAME = 7;
		var gCOL_POPULAR = 8;
		var gCOL_TRENDING = 9;
		var gCOL_ACTION = 10;

		var gTableCourses = $("#table-courses").DataTable({
			columns: [
				{ data: gNAME[gCOL_NO] },
				{ data: gNAME[gCOL_COURSE_CODE] },
				{ data: gNAME[gCOL_COURSE_NAME] },
				{ data: gNAME[gCOL_PRICE] },
				{ data: gNAME[gCOL_DISCOUNT_PRICE] },
				{ data: gNAME[gCOL_DURATION] },
				{ data: gNAME[gCOL_LEVEL] },
				{ data: gNAME[gCOL_TEACHER_NAME] },
				{ data: gNAME[gCOL_POPULAR] },
				{ data: gNAME[gCOL_TRENDING] },
				{ data: gNAME[gCOL_ACTION] },
			],
			columnDefs: [
				{
					targets: gCOL_NO,
					render: function (paramData, paramType, paramRow, paramMeta) {
						return paramMeta.row + 1;
					},
				},
				{
					targets: gCOL_ACTION,
					defaultContent: `<i class="fas fa-edit btn-edit" title="Edit Course" style="cursor:pointer;"></i>
		                        <i class="fas fa-trash btn-delete" title="Delete Course" style="cursor:pointer;"></i>`,
				},
			],
		});

		var gId;
		/*** REGION 2 - Elements' events declaration */
		$(document).ready(function () {
			onPageLoading();

			// all the btn to add a new course
			$("#btn-add-course").on("click", function () {
				onBtnAddCourseClick();
			});

			$("#btn-add-create-course").on("click", function () {
				onBtnCreateCourseClick();
			});

			$("#modal-add-course").on("hidden.bs.modal", function () {
				$("#modal-add-course").find("form").trigger("reset");
			});

			//all the btn to edit a course
			$("#table-courses").on("click", ".btn-edit", function () {
				onBtnEditClick(this);
			});

			$("#btn-edit-update-course").on("click", function () {
				onBtnUpdateClick(this);
			});

			//all the btn to delete a course
			$("#table-courses").on("click", ".btn-delete", function () {
				onBtnDeleteClick(this);
			});

			$("#btn-delete-confirm-course").on("click", function () {
				onBtnConfirmLCick(this);
			});
		});
		/*** REGION 3 - Event handlers */
		//runs when page load
		function onPageLoading() {
			callAPIGetAllCourses();
		}

		//runs when Add Course btn is clicked
		function onBtnAddCourseClick() {
			var vModalAddCourse = $("#modal-add-course");
			vModalAddCourse.modal("show");
		}

		//runs when Create Course btn is clicked
		function onBtnCreateCourseClick() {
			//get the course
			var vCourseObj = {
				courseCode: "",
				courseName: "",
				price: -1,
				discountPrice: -1,
				duration: "",
				level: "",
				coverImage: "",
				teacherName: "",
				teacherPhoto: "",
				isPopular: false,
				isTrending: false,
			};

			//get the adding course
			getAddCourse(vCourseObj);
			//validate information of the course
			var vValid = validateCourseData(vCourseObj);
			if (vValid) {
				callAPICreateCourse(vCourseObj);
			}
		}

		//runs when Edit btn is clicked
		function onBtnEditClick(paramEditBtn) {
			$("#modal-edit-course").modal("show");
			gId = getIdFromButton(paramEditBtn);
			var vCourse = callAPIGetCourseById(gId);
			showCourseOnEdit(vCourse);
		}

		//runs when Update btn is clicked
		function onBtnUpdateClick() {
			//get the course
			var vCourseObj = {
				courseCode: "",
				courseName: "",
				price: -1,
				discountPrice: -1,
				duration: "",
				level: "",
				coverImage: "",
				teacherName: "",
				teacherPhoto: "",
				isPopular: false,
				isTrending: false,
			};

			//get the adding course
			getEditCourse(vCourseObj);
			//validate information of the course
			var vValid = validateCourseData(vCourseObj);
			if (vValid) {
				callAPIUpdateCourse(vCourseObj, gId);
			}
		}

		//runs when Delete btn is clicked
		function onBtnDeleteClick(paramDeleteBtn) {
			$("#modal-delete-course").modal("show");
			gId = getIdFromButton(paramDeleteBtn);
		}

		//runs when Confirm btn is clicked
		function onBtnConfirmLCick() {
			callAPIDeleteCourseById(gId);
		}
		/*** REGION 4 - Common funtions */
		//call api to get all courses
		function callAPIGetAllCourses() {
			$.ajax({
				type: "GET",
				url: gBASE_URL + "/courses",
				success: function (paramRes) {
					loadCoursesToTable(paramRes);
				},
				error: function (paramErr) {
					alert("Can't get courses");
				},
			});
		}

		//load courses to table
		//input: array of the courses
		function loadCoursesToTable(paramCourses) {
			gTableCourses.clear();
			gTableCourses.rows.add(paramCourses);
			gTableCourses.draw();
		}

		//get add course
		//input: the course obj
		function getAddCourse(paramCourseObj) {
			paramCourseObj.courseCode = $("#inp-add-course-code").val().trim();
			paramCourseObj.courseName = $("#inp-add-course-name").val().trim();
			paramCourseObj.price = $("#inp-add-price").val().trim();
			paramCourseObj.discountPrice = $("#inp-add-discount-price").val().trim();
			paramCourseObj.duration = $("#inp-add-duration").val().trim();
			paramCourseObj.level = $("#select-add-level").val();
			paramCourseObj.coverImage = $("#inp-add-cover-image").val().trim();
			paramCourseObj.teacherName = $("#inp-add-teacher-name").val().trim();
			paramCourseObj.teacherPhoto = $("#inp-add-teacher-photo").val().trim();
			paramCourseObj.isPopular = $("#ckb-add-popular").is(":checked");
			paramCourseObj.isTrending = $("#ckb-add-trending").is(":checked");
		}

		//validate course data
		//input: course obj
		function validateCourseData(paramCourseObj) {
			if (paramCourseObj.courseCode == "") {
				alert("No Course Code");
				return false;
			}

			if (paramCourseObj.courseCode.length < 10) {
				alert("Enter Course Code again");
				return false;
			}

			if (paramCourseObj.courseName == "") {
				alert("No Course Name");
				return false;
			}

			if (paramCourseObj.courseName.length < 20) {
				alert("Enter Course Name again");
				return false;
			}

			if (paramCourseObj.price == "") {
				alert("No Price");
				return false;
			}

			if (!Number.isInteger(Number(paramCourseObj.price)) || paramCourseObj.price <= 0) {
				alert("Enter Price again");
				return false;
			}

			if (
				paramCourseObj.discountPrice != "" &&
				(!Number.isInteger(Number(paramCourseObj.discountPrice)) || paramCourseObj.discountPrice < 0 || Number(paramCourseObj.discountPrice) > Number(paramCourseObj.price))
			) {
				alert("Enter Discount Price again");
				return false;
			}

			if (paramCourseObj.duration == "") {
				alert("No Duration");
				return false;
			}

			if (paramCourseObj.coverImage == "") {
				alert("No Cover Image");
				return false;
			}

			if (paramCourseObj.teacherName == "") {
				alert("No Teacher Name");
				return false;
			}

			if (paramCourseObj.teacherPhoto == "") {
				alert("No Teacher Photo");
				return false;
			}

			return true;
		}

		//create new course
		//input: a course obj
		function callAPICreateCourse(paramCourseObj) {
			$.ajax({
				type: "POST",
				url: gBASE_URL + "/courses",
				data: JSON.stringify(paramCourseObj),
				contentType: "application/json",
				success: function (paramRes) {
					alert("Created course successfully");
					$("#modal-add-course").modal("hide");
					callAPIGetAllCourses();
				},
				error: function (paramErr) {
					alert("Can't create new course");
				},
			});
		}

		// get user id from btn (edit or delete)
		function getIdFromButton(paramButton) {
			var vTableRow = $(paramButton).parents("tr");
			var vRowData = gTableCourses.row(vTableRow).data();
			return vRowData.id;
		}

		//call api to get course
		//input: id of a course
		function callAPIGetCourseById(paramId) {
			var vRes;
			$.ajax({
				async: false,
				type: "GET",
				url: gBASE_URL + "/courses/" + paramId,

				success: function (paramRes) {
					vRes = paramRes;
				},
				error: function (paramErr) {
					alert("Can't get course");
				},
			});
			return vRes;
		}

		//show course
		//input: a course obj
		function showCourseOnEdit(paramCourseObj) {
			$("#inp-edit-course-code").val(paramCourseObj.courseCode);
			$("#inp-edit-course-name").val(paramCourseObj.courseName);
			$("#inp-edit-price").val(paramCourseObj.price);
			$("#inp-edit-discount-price").val(paramCourseObj.discountPrice);
			$("#inp-edit-duration").val(paramCourseObj.duration);
			$("#select-edit-level").val(paramCourseObj.level);
			$("#inp-edit-cover-image").val(paramCourseObj.coverImage);
			$("#inp-edit-teacher-name").val(paramCourseObj.teacherName);
			$("#inp-edit-teacher-photo").val(paramCourseObj.teacherPhoto);
			if (paramCourseObj.isPopular) {
				$("#ckb-edit-popular").prop("checked", true);
			} else {
				$("#ckb-edit-popular").prop("checked", false);
			}
			if (paramCourseObj.isTrending) {
				$("#ckb-edit-trending").prop("checked", true);
			} else {
				$("#ckb-edit-trending").prop("checked", false);
			}
		}

		//get edit course
		//input: the course obj
		function getEditCourse(paramCourseObj) {
			paramCourseObj.courseCode = $("#inp-edit-course-code").val().trim();
			paramCourseObj.courseName = $("#inp-edit-course-name").val().trim();
			paramCourseObj.price = $("#inp-edit-price").val().trim();
			paramCourseObj.discountPrice = $("#inp-edit-discount-price").val().trim();
			paramCourseObj.duration = $("#inp-edit-duration").val().trim();
			paramCourseObj.level = $("#select-edit-level").val();
			paramCourseObj.coverImage = $("#inp-edit-cover-image").val().trim();
			paramCourseObj.teacherName = $("#inp-edit-teacher-name").val().trim();
			paramCourseObj.teacherPhoto = $("#inp-edit-teacher-photo").val().trim();
			paramCourseObj.isPopular = $("#ckb-edit-popular").is(":checked");
			paramCourseObj.isTrending = $("#ckb-edit-trending").is(":checked");
		}

		//call api update course
		//input: a course obj
		function callAPIUpdateCourse(paramCourseObj, paramId) {
			$.ajax({
				type: "PUT",
				url: gBASE_URL + "/courses/" + paramId,
				data: JSON.stringify(paramCourseObj),
				contentType: "application/json",
				success: function (paramRes) {
					alert("Update course successfully");
					$("#modal-edit-course").modal("hide");
					callAPIGetAllCourses();
				},
				error: function (paramErr) {
					alert("Can't update course");
				},
			});
		}

		//call api to delete course by id
		//input: id of a course
		function callAPIDeleteCourseById(paramId) {
			$.ajax({
				type: "DELETE",
				url: gBASE_URL + "/courses/" + paramId,

				success: function (paramRes) {
					alert("Delete course successfully");
					$("#modal-delete-course").modal("hide");
					callAPIGetAllCourses();
				},
				error: function (paramErr) {
					alert("Can't delete course");
				},
			});
		}
	</script>
</html>
